<?php

	// Perform Login
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();
	
	// Check Array Input
	PHPCUS_PARAM::CUS_DOES_NOT_SUPPORT_ARRAY();
	
	// Check already authenticated
	PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();
	// Check access rights
	PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_ONLY, 'account_apk');
	
	if
	(
		PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
		(
			[
					'PARAM_ACC_APK_ID',
					'PARAM_ACC_APK_DESCRIPTION',
					'PARAM_ACC_APK_CODE',
					'PARAM_ACC_APK_SERIAL',
					'PARAM_ACC_APK_SETTINGS_A',
					'PARAM_ACC_APK_SETTINGS_B',
					'PARAM_ACC_APK_SETTINGS_C',
					'PARAM_ACC_APK_SETTINGS_D',
					'PARAM_ACC_APK_SETTINGS_E',
					'PARAM_ACC_APK_REMARKS',
					'PARAM_ACC_APK_EXPIRTY_FROM',
					'PARAM_ACC_APK_EXPIRTY_TO',
					'PARAM_ACC_APK_STATUS',
					
					'PARAM_ORDER_FIELD',
					'PARAM_ORDER_TYPE',
					'PARAM_SKIP',
					'PARAM_LIMIT'
			], True
		)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------	
			$PARAM_ACC_APK_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_ACC_APK_ID');
			$PARAM_ACC_APK_DESCRIPTION = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ACC_APK_DESCRIPTION');
			$PARAM_ACC_APK_CODE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ACC_APK_CODE');
			$PARAM_ACC_APK_SERIAL = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ACC_APK_SERIAL');
			$PARAM_ACC_APK_SETTINGS_A = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ACC_APK_SETTINGS_A');
			$PARAM_ACC_APK_SETTINGS_B = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ACC_APK_SETTINGS_B');
			$PARAM_ACC_APK_SETTINGS_C = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ACC_APK_SETTINGS_C');
			$PARAM_ACC_APK_SETTINGS_D = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ACC_APK_SETTINGS_D');
			$PARAM_ACC_APK_SETTINGS_E = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ACC_APK_SETTINGS_E');
			$PARAM_ACC_APK_REMARKS = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ACC_APK_REMARKS');
			$PARAM_ACC_APK_EXPIRTY_FROM = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_ACC_APK_EXPIRTY_FROM');
			$PARAM_ACC_APK_EXPIRTY_TO = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_ACC_APK_EXPIRTY_TO');
			$PARAM_ACC_APK_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_ACC_APK_STATUS');
			
			$PARAM_ORDER_FIELD = PHPCUS_PARAM::CUS_READ_SORT_FIELD
			(
					'PARAM_ORDER_FIELD',
					[
						'ACC_APK_ID', 
						'ACC_APK_DESCRIPTION', 
						'ACC_APK_CODE', 
						'ACC_APK_SERIAL', 
						'ACC_APK_SETTINGS_A', 
						'ACC_APK_SETTINGS_B', 
						'ACC_APK_SETTINGS_C', 
						'ACC_APK_SETTINGS_D', 
						'ACC_APK_SETTINGS_E', 
						'ACC_APK_REMARKS', 
						'ACC_APK_EXPIRTY', 
						'ACC_APK_STATUS'
					]
			);		
			$PARAM_ORDER_TYPE = PHPCUS_PARAM::CUS_READ_SORT_TYPE('PARAM_ORDER_TYPE');
			$PARAM_SKIP	= PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_SKIP');
			$PARAM_LIMIT = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_LIMIT');
			
			// ------------------------------------------------------------------
			
			
			// Populate Map Array
			// ...........................................
			$GET_MAP_ARRAY = PHPCUS_ACCOUNT_APK::CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
			
			$GET_MAP_ARRAY['PARAM_ACC_APK_ID'] = $PARAM_ACC_APK_ID;
			$GET_MAP_ARRAY['PARAM_ACC_APK_DESCRIPTION'] = $PARAM_ACC_APK_DESCRIPTION;
			$GET_MAP_ARRAY['PARAM_ACC_APK_CODE'] = $PARAM_ACC_APK_CODE;
			$GET_MAP_ARRAY['PARAM_ACC_APK_SERIAL'] = $PARAM_ACC_APK_SERIAL;
			$GET_MAP_ARRAY['PARAM_ACC_APK_SETTINGS_A'] = $PARAM_ACC_APK_SETTINGS_A;
			$GET_MAP_ARRAY['PARAM_ACC_APK_SETTINGS_B'] = $PARAM_ACC_APK_SETTINGS_B;
			$GET_MAP_ARRAY['PARAM_ACC_APK_SETTINGS_C'] = $PARAM_ACC_APK_SETTINGS_C;
			$GET_MAP_ARRAY['PARAM_ACC_APK_SETTINGS_D'] = $PARAM_ACC_APK_SETTINGS_D;
			$GET_MAP_ARRAY['PARAM_ACC_APK_SETTINGS_E'] = $PARAM_ACC_APK_SETTINGS_E;
			$GET_MAP_ARRAY['PARAM_ACC_APK_REMARKS'] = $PARAM_ACC_APK_REMARKS;
			$GET_MAP_ARRAY['PARAM_ACC_APK_EXPIRTY_FROM'] = $PARAM_ACC_APK_EXPIRTY_FROM;
			$GET_MAP_ARRAY['PARAM_ACC_APK_EXPIRTY_TO'] = $PARAM_ACC_APK_EXPIRTY_TO;
			$GET_MAP_ARRAY['PARAM_ACC_APK_STATUS'] = $PARAM_ACC_APK_STATUS;
			
			$GET_MAP_ARRAY["PARAM_ORDER_FIELD"] = $PARAM_ORDER_FIELD;
			$GET_MAP_ARRAY["PARAM_ORDER_TYPE"] = $PARAM_ORDER_TYPE;
			$GET_MAP_ARRAY["PARAM_SKIP"] = $PARAM_SKIP;
			$GET_MAP_ARRAY["PARAM_LIMIT"] = $PARAM_LIMIT;
			
			
			// Execute Stored Procedure
			// ...........................................
			$DATA_SET = PHPCUS_ACCOUNT_APK::CUS_GET_SUM_MA($GET_MAP_ARRAY);
			
						
			// Return JSON response
			// ...........................................
			if(empty($DATA_SET) === False)
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS($DATA_SET);
			}
			else
			{
				PHPCUS_PARAM::CUS_JSON_SUCCESS('');
			}
			
		}
		Catch(Exception $ERR)
		{		
			PHPVC_LOG::VAR_REPORT_ERROR($ERR, 0);
			if(isset($_SERVER['HTTP_ORIGIN']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_ORIGIN', $_SERVER['HTTP_ORIGIN']);
			}
			if(isset($_SERVER['HTTP_HOST']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_HOST', $_SERVER['HTTP_HOST']);
			}		
			if(isset($_SERVER['HTTP_REFERER']))
			{
			    PHPVC_LOG::VAR_ERROR('HTTP_REFERER', $_SERVER['HTTP_REFERER']);
			}
			if(isset($_SERVER['REMOTE_ADDR']))
			{
			    PHPVC_LOG::VAR_ERROR('REMOTE_ADDR', $_SERVER['REMOTE_ADDR']);
			}
			
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR->getMessage());
		}
	}
	else
	{
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>